config/routes.rb
Rails.application.routes.draw do
  root 'professors#index'
  devise_for :users
  mount RailsAdmin::Engine => '/admin', as: 'rails_admin'
  resources :professors do
  	resources :comments
  	member do
  		put "bom", to: "professors#vote"
  		put "ruim", to: "professors#unvote"
  	end
  end 
end

app/models/comment.rb
class Comment < ActiveRecord::Base
	validates :text, presence: true
	belongs_to :professor
end

app/models/professor.rb
class Professor < ActiveRecord::Base
	has_many :comments
	validates :name, presence: true 
	acts_as_votable
	has_attached_file :avatar, styles: { medium: "300x300>", thumb: "100x100>" }, default_url: "/images/:style/missing.png"
  	validates_attachment_content_type :avatar, content_type: /\Aimage\/.*\Z/
end

app/models/user.rb
class User < ActiveRecord::Base
	acts_as_voter
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController

	def create
		@professor = Professor.find(params[:professor_id])
		@comment = @professor.comments.create(comments_params)
		redirect_to "/"
	end 

	private
	def comments_params
		params.require(:comment).permit(:text)
	end
end

app/controllers/professors_controller.rb
class ProfessorsController < ApplicationController

	before_action :authenticate_user!

	def index
		@professors = Professor.all 
	end

	def show
		@professor = Professor.find(params[:id])
	end 
	
	def new
		@professor = Professor.new(:name => 'professor')
		@professor.save
	end

	def create
		@professor = Professor.create(professor_params)
	end

	def vote
		@professor = Professor.find(params[:id])
		@professor.upvote_by current_user
		flash[:message] = "Obrigado por votar"
		redirect_to :back
	end

	def unvote 
		@professor = Professor.find(params[:id])
		@professor.downvote_by current_user
		flash[:message] = "Obrigado por votar"
		redirect_to :back
	end

	private
	def professor_params
		params.require(:professor).permit(:avatar, :name)
	end 
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/professors_helper.rb
module ProfessorsHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Reviewer</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>

<%= yield %>

</body>
</html>

app/views/professors/index.html.erb
<body class="margin-index">
	<div class="container">
		<%if user_signed_in?%>
			<p class="text-right">Signed as <%= current_user.email %>
			<%= link_to "Logout", destroy_user_session_path, :method => :delete, :class => 'btn btn-primary' %>
			</p>
		<%end%>
		<div class="panel panel-primary">

			<div class="panel heading">
			<h2 class="text-center">Professores</h2>
			</div>

			<div class="panel-body">
					<% @professors.each do |prof| %>
						<div class="col-md-offset-1">
							<div class="row col-md-6 linha">
								<div class="col-md-6">
									<%= image_tag(prof.avatar.url(:medium), :class => "img-rounded foto") %>
								</div>
								<div class="col-md-6">
									<h3><%= prof.name %></h3>
									<p>Avalie esse professor</p>
									<p><%= link_to "Avaliar", prof, :class => "controls btn btn-primary btn-lg"%></p>
								</div>
							</div>
						</div>
					<% end %>
			</div>

		</div>
	</div>
</body>

app/views/professors/show.html.erb
<body class="margin-prof">
	<div class="container">
		<div class="panel panel-default">
			<div class="panel-body">
				<div class="col-md-offset-3">

					<div class="col-md-4">
						<%= image_tag(@professor.avatar.url(:medium), :class => "img-rounded") %>
					</div>
					<div class="col-md-8">
						<h3 class="margin-parag"><strong><%= @professor.name %></strong></h3>	

						<h6 class="margin-parag">Avalie e adicione um comentário</h6>

						<%= link_to bom_professor_path(@professor), method: :put, :class => "btn btn-primary margin-parag" do %>
						  Bom
						  <%= @professor.get_upvotes.size %>
						<% end %>
						<%= link_to ruim_professor_path(@professor), method: :put, :class => "btn btn-primary margin-parag" do %>
						  Ruim
						  <%= @professor.get_downvotes.size %>
						<% end %>

						<%= simple_form_for([@professor, @professor.comments.build]) do |comment| %>
							<p class="margin-parag>
								<%= comment.label :Comentário %><br>
								<%= comment.text_area :text %>
							</p>

							<p>
								<%= comment.submit :Enviar, :class => "btn btn-primary" %>
								<%= link_to "Voltar", :bacqk %>
							</p>

						<%end%>
					</div>
				</div>
			</div>
		</div>
	</div>
</body>